<?php
/**
 * Created by PhpStorm.
 * User: ep
 * Date: 12/23/15
 * Time: 6:33 PM
 */


namespace qfq;

use qfq;
use qfq\exceptions\UserException;
use qfq\store;

require_once(__DIR__ . '/../qfq/store/Store.php');
require_once(__DIR__ . '/../qfq/Constants.php');
require_once(__DIR__ . '/../qfq/helper/KeyValueStringParser.php');
require_once(__DIR__ . '/../qfq/exceptions/UserException.php');

class Form {

    protected $config = null;
    protected $store = null;
//    protected $formElements = null;
//    protected $userLog = null;

    /*
     *
     */
    public function __construct($bodytext = '') {

        /*
         * TODO:
         *  Preparation: setup logging, database access, record locking
         *  fill stores
         *  Check permission_create / permission_update
         *  Multi: iterate over all records, Single: activate record
         *      Check mode: Load | Save
         *      doActions 'Before'
         *      Do all FormElements
         *      doActions 'After'
         */

        $this->store = \qfq\store\Store::getInstance($bodytext);
    }


    /*
     *
     */

    public function process() {

        $this->loadFormDefinition();

//        $val = $this->store->getVar('key01',STORE_CLIENT);

        return "Hello World from class Form";
    }


    private function loadFormDefinition() {

        $formName = $this->getFormName();

        echo "Formname: $formName";
    }

    /**
     * @return string
     * @throws UserException
     * @throws exceptions\CodeException
     */

    private function getFormName() {

        // store: T3 Bodytext
        $formName = $this->store->getVar(T3_BODYTEXT_FORM, STORE_T3_BODYTEXT);
        if ($formName !== false)
            return $formName;

        // store: SIP
//        $fomName = $this->store->getVar(????_FORM, STORE_SIP);
//        if($formName !== false)
//            return $formName;

        // store: CLIENT
        $formName = $this->store->getVar(CLIENT_FORM, STORE_CLIENT);
        if ($formName !== false)
            return $formName;

        throw new UserException("Missing form name. Not found in T3_BODYTEXT / SIP / GET", ERROR_MISSING_FORM_NAME);
    }

}