<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/1/16
 * Time: 12:43 PM
 */

namespace qfq\exceptions;

/**
 * Class UserException
 *
 * Thrown by Form or FormElement on User errors
 *
 * @package qfq\exceptions
 */

class CodeException extends \Exception {

    /*
     * @return string HTML formatted error string
     */
    public function formatMessage() {
        $message = '<table border="1">';
        $message .= '<tr bgcolor="#dddddd"><td>Action</td><td>Code Exception</td></tr>' ;
        $message .= '<tr bgcolor="#dddddd"><td>File</td><td>'. $this->getFile(). '</td></tr>' ;
        $message .= '<tr bgcolor="#dddddd"><td>Line</td><td>'. $this->getLine(). '</td></tr>' ;
        $message .= '<tr bgcolor="#dddddd"><td>Message</td><td>'. $this->getMessage(). '</td></tr>' ;
        $message .= '<tr bgcolor="#dddddd"><td>Code</td><td>'. $this->getCode(). '</td></tr>' ;
        $message .= '<tr bgcolor="#dddddd"><td>Stacktrace</td><td>'. str_replace("\n", "<br>", $this->getTraceAsString()). '</td></tr>' ;
        $message .= '</table>';

        return($message);
    }
}