<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/1/16
 * Time: 8:35 PM
 */

const QFQ_INI = "qfq.ini";  // QFQ configuration file: db access

// Sanatize Classifier
const SANATIZE_ALNUMX = "alnumx";
const SANATIZE_DIGIT = "digit";
const SANATIZE_ALL = "all";
const SANATIZE_DEFAULT = SANATIZE_DIGIT;

// dbQuerySimple
const ROW_REGULAR = "regular";
const ROW_IMPLODE_ALL = "implode_all";
const ROW_EXACT_1 = "exact_1";
const ROW_EMPTY_IS_OK = "empty_is_ok";

// QFQ Error Codes
const ERROR_UNKNOW_SANATIZE_CLASS = 1001;
const ERROR_OPEN_DATABASE = 1002;
// 1003;
const ERROR_VALUE_ALREADY_CODPIED = 1004;
// 1005
const ERROR_MISSING_FORM_NAME = 1006;
const ERROR_IN_SQL_STATEMENT = 1007;
const ERROR_READ_FILE = 1008;
// DB Errors
//const ERROR_DB_QUERY_SIMPLE = 2000;
const ERROR_DB_GENERIC_CHECK = 2001;
const ERROR_DB_TOO_FEW_ROWS = 2002;
const ERROR_DB_TOO_MANY_ROWS = 2003;
//
// Store Names: Identifier
//
const STORE_FORM = "F";  // form, still not saved in database
const STORE_SIP = "S"; // SIP
const STORE_RECORD = "R"; // selected record from primary table.
const STORE_TABLE_DEFINITION = "T"; // table definition in database of primary table
const STORE_CLIENT = "C"; // Client: POST variable, if not found: GET variable
const STORE_T3_BODYTEXT = "B"; // Typo3 > Page content record > bodytext
const STORE_ZERO = "0"; // value: 0, might helpfull if variable is empty but used in an SQL statement, which might produce a SQL error otherwise if substituted with an empty string
const STORE_SYSTEM = "Y"; // various system values like db connection credentials
const STORE_DEF_FORM = "O"; // Store for the Form defition. 1:1 copy of the record from table 'form'
const STORE_DEF_FORM_ELEMENT = "E"; // Store for the FormEelements. 1:1 copy of the record from table 'formelement'

const USE_STORE_DEFAULT = "FSRT";

//
// Store: Definitions
//

// URL variables
const CLIENT_FORM = 'form';
const CLIENT_SIP = 's';
const CLIENT_RECORD_ID = 'r ';
const CLIENT_KEY_SEM_ID = 'keySemId';
const CLIENT_KEY_SEM_ID_USER = 'keySemIdUser';
const CLIENT_PAGE_ID = 'pageId';
const CLIENT_PAGE_TYPE = 'pageType';
const CLIENT_PAGE_LANGUAGE = 'pageLanguage';

// T3 Bodytext Keywords
const T3_BODYTEXT_FORM = CLIENT_FORM;
const T3_BODYTEXT_DEBUG_LOAD = 'debugLoad';
const T3_BODYTEXT_DEBUG_SAVE = 'debugSave';

// System
const SYSTEM_DBUSER = 'DBUSER';
const SYSTEM_DBSERVER = 'DBSERVER';
const SYSTEM_DBPW = 'DBPW';
const SYSTEM_DB = 'DB';
const SYSTEM_TESTDB = 'TESTDB';
const SYSTEM_SESSIONNAME = 'SESSIONNAME';
const SYSTEM_DBH = 'dataBaseHandle';

const SYSTEM_FORM = CLIENT_FORM; // Final form to process.
const SYSTEM_FORM_ELEMENT = 'formElement'; // Formelement which are processed at the moment. Useful for error reporting.
const SYSTEM_FORM_ELEMENT_FIELD = 'formElementField'; // Fieldname of processed Formelement. Useful for error reporting.
const SYSTEM_SQL_RAW = 'sqlRaw';  // SQL Query (before substitute). Useful for error reporting.
const SYSTEM_SQL_FINAL = 'sqlFinal'; //  SQL Query (after substitute). Useful for error reporting.
const SYSTEM_SQL_COUNT = 'sqlCount'; //  Number of rows in SQL ResultSet. Useful for error reporting.

// FORM - copy from table 'form' of processed form
const DEF_FORM_NAME = CLIENT_FORM;

// FORMELEMENT - copy of all formElements of processed form
const DEF_FORM_ELEMENT_ID = 'id';